(function ($) {
    $.fn.scaleslider = function (options) {


        // Default settings ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        var s = this; // bind loded object !

        var settings = $.extend({
            sliderWidth: '100%',
            sliderHeight: 150,
            dotNavigation: true,
            arrowNavigation: true,
            keyNavigation: true,
            transitionType: 'scale'
        }, options);
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        // Default variables ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        var singleSliderArray = [];
        var singleCycle = 0;
        var singleImage = $('.singleSlide img');
        var singleSlide = $('.singleSlide');

        var topMenuLink = $('.singleMenu ul li a');
        $('.singleSlideContainer').css({
            'height': settings.sliderHeight,
            'margin-top': -(settings.sliderHeight / 2)
        });
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////       

        // Accepting external settings /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        if (settings.dotNavigation === false) {} else {
            this.append('<div class="singleDotsContainer"></div>');
        }
        if (settings.arrowNavigation === false) {
            $('.singleArrow').remove();
        } else {
            this.append('<div class="singleArrow saLeft"></div>');
            this.append('<div class="singleArrow saRight"></div>');
        }
        if (settings.keyNavigation === false) {} else {
            $(document).keydown(function (e) {
                switch (e.which) {
                case 37: // left arrow
                    singleSlideCycle('left', null);
                    break;
                case 39: // right arrow
                    singleSlideCycle('right', null)
                    break;
                default:
                    return;
                }
                e.preventDefault();
            });
        }
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



        // Helper functions ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        var positionDots = function () {
            // this function positions DotContainer dead in the middle
            var singleDotsContainer = $('.singleDotsContainer');
            var singleDotContainerWidth = singleDotsContainer.outerWidth();
            singleDotsContainer.css({
                'margin-left': -(singleDotContainerWidth / 2)
            });
        }

        var cycleNumber = function () {
                // This function returns current active slide
                return parseInt(singleSlide.attr('ssid'));
            }
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        // Transition functions for the slider /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        var scaleType = function (s) {
            s.find('img').each(function (i) {

                $('.singleDotsContainer').append('<div class="singleDot" dot-number="' + i + '"</div>');
                $('.singleSlide [dot-number="0"]').addClass('singleDotActive');

                singleSliderArray.push(i);
                $(this).closest('.singleSlide').attr('ssid', 0);
                $('.singleSlide img [singleslideid="0"]').addClass('singleInView');

                var sliderWidth = $(this).outerWidth();
                var sliderHeight = $(this).outerHeight();

                $(this).css({
                    'margin-top': -(sliderHeight / 2)
                });

                $(this).attr('singleSlideId', i);

                if (i !== 0) {
                    $(this).removeClass('singleInView');
                } else {
                    $(this).css({
                        'margin-top': -(sliderHeight / 2)
                    }).addClass('singleInView');
                }
                positionDots();
            });
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        // Slider transitions //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //
        //


        switch (settings.transitionType) {
        case 'scale':
            scaleType(this);
            break;
        case 'slide':
            console.log('slide');
            break;
        case 'opactiy':
            console.log('opactiy');
            break;
        case 'updown':
            console.log('updown');
            break;
        default: // 'scale'
            console.log('scale is a defaulf transition type for this slider');
        }


        //
        //
        //

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        // Slider controll functions ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        var singleSlideCycle = function (direction, dotNumber) {
            if (direction == null) {
                $('.singleDot').removeClass('singleDotActive');
                singleImage.removeClass('singleInView');
                singleSlide.attr('ssid', dotNumber);
                $('.singleSlide [dot-number="' + dotNumber + '"]').addClass('singleDotActive');
                $('.singleSlideContainer img[singleSlideId="' + dotNumber + '"]').addClass('singleInView');
            } else {
                $('.singleDot').removeClass('singleDotActive');
                singleImage.removeClass('singleInView');

                if (direction == 'left') {
                    if (cycleNumber() <= 0) {
                        singleCycle = singleSliderArray.length - 1;
                    } else {
                        singleCycle = cycleNumber() - 1;
                    }
                    singleSlide.attr('ssid', singleCycle);
                } else {
                    if (cycleNumber() == singleSliderArray.length - 1) {
                        singleCycle = 0;
                    } else {
                        singleCycle = cycleNumber() + 1;
                    }
                    singleSlide.attr('ssid', singleCycle);
                }
                $('.singleSlide [dot-number="' + singleCycle + '"]').addClass('singleDotActive');
                $('.singleSlideContainer img[singleSlideId="' + singleCycle + '"]').addClass('singleInView');
            }
        }

        $(document).on('click', '.saLeft', function () {
            singleSlideCycle('left', null);
        });
        $(document).on('click', '.saRight', function () {
            singleSlideCycle('right', null);
        });
        $(document).on('click', '.singleDot', function () {
            singleSlideCycle(null, $(this).attr('dot-number'));
        });

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        // Window resize functions /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        var viewportAdapt = function () {
            $('.singleSlide').css({
                'width': settings.sliderWidth,
                'height': settings.sliderHeight
            });
        }
        viewportAdapt();

        $(window).on('resize', function () {
            viewportAdapt();
        });
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

    };
})(jQuery);